<?php
use CRM_Bij1migratie_ExtensionUtil as E;

// /**
//  * Lid.Indelen API specification (optional)
//  * This is used for documentation and validation.
//  *
//  * @param array $spec description of fields supported by this API call
//  */
// function _civicrm_api3_lid_Indelen_spec(&$spec) {
//   $spec['min']['api_required'] = 1;
// }

// /**
//  * Lid.Indelen API
//  * Haal alle contacten die een bijdrage hebben en:
//  * - bekijk of ze het basisbedrag betaald hebben in 2021, zo ja zet in standaard leden en haal uit nieuwe leden
//  * - zo nee:
//  *   - zet in ex-leden als ze helemaal geen betalingen in 2021 hebben
//  *   - zet in groep nog in te delen leden als ze wel in 2021 betaald hebben
//  *   - haal ze uit nieuwe leden
//  *
//  * @param array $params
//  *
//  * @return array
//  *   API result descriptor
//  *
//  * @see civicrm_api3_create_success
//  *
//  * @throws API_Exception
//  */
// function civicrm_api3_lid_Indelen($params) {
//   $min = (int) $params['min'];
//   $vanDatum = new DateTime('2021-01-01');
//   $totDatum = new DateTime('2021-12-31');
//   $contact = new CRM_Bij1migratie_Contact();
//   $groep = new CRM_Bij1algemeen_Groep();
//   $groepCount = CRM_Core_DAO::singleValueQuery("SELECT COUNT(*) FROM civicrm_group WHERE name = %1", [1 => ["bij1_nog_in_te_delen", "String"]]);
//   if ($groepCount == 0) {
//     $groep->maakGroep([
//       'name' => "bij1_nog_in_te_delen",
//       'title' => "Nog in te delen na migratie",
//       'description' => "Deze groep bevat alle contacten die betaald hebben waarvan nog geen groepsindeling duidelijk is",
//     ]);
//   }
//   $nogInTeDelenGroepId = CRM_Core_DAO::singleValueQuery("SELECT id FROM civicrm_group WHERE name = %1", [1 => ["bij1_nog_in_te_delen", "String"]]);
//   $returnValues = [];
//   $lid = CRM_Core_DAO::executeQuery("SELECT DISTINCT(contact_id) FROM civicrm_contribution WHERE contact_id >= %1 ORDER BY contact_id LIMIT 1000", [1 => [$min, "Integer"]]);
//   while ($lid->fetch()) {
//     $maxContactId = $lid->contact_id;
//     $inschrijvingsDatum = $contact->haalInschrijvingsDatum((int) $lid->contact_id);
//     if ($contact->heeftBasisBetaald((int) $lid->contact_id, $vanDatum, $totDatum)) {
//       $groep->plaatsInGroep((int) $lid->contact_id, Civi::service('bij1algemeen')->getStandaardLedenGroepId(), $vanDatum);
//       $groep->verwijderUitGroep((int) $lid->contact_id, Civi::service('bij1algemeen')->getNieuweLedenGroepId(), TRUE);
//     }
//     elseif ($contact->heeftRecentBetaald((int) $lid->contact_id)) {
//         $groep->plaatsInGroep((int) $lid->contact_id, Civi::service('bij1algemeen')->getNieuweLedenGroepId(), $inschrijvingsDatum);
//         $returnValues[] = $lid->contact_id . " in nieuwe.";
//     }
//     elseif ($contact->heeftMislukt((int) $lid->contact_id, $vanDatum, $totDatum)) {
//       $groep->plaatsInGroep((int) $lid->contact_id, Civi::service('bij1algemeen')->getStandaardLedenGroepId(), $vanDatum);
//       $groep->plaatsInGroep((int) $lid->contact_id, Civi::service('bij1algemeen')->getBetalingGemistLedenGroepId(), $inschrijvingsDatum);
//       $groep->verwijderUitGroep((int) $lid->contact_id, Civi::service('bij1algemeen')->getNieuweLedenGroepId(), TRUE);
//       $returnValues[] = $lid->contact_id . " in betaling gemist en standaard.";
//     }
//     else {
//       $groep->plaatsInGroep((int) $lid->contact_id, $nogInTeDelenGroepId);
//       $groep->verwijderUitGroep((int) $lid->contact_id, Civi::service('bij1algemeen')->getNieuweLedenGroepId(), TRUE);
//     }
//   }
//   $returnValues[] = ", de rest in standaard of nog in te delen. Laatste verwerkte contact is " . $maxContactId;
//   return civicrm_api3_create_success($returnValues, $params, 'Lid', 'Indelen');
// }
