<?php

class CRM_Bij1migratie_Mapping_ChargebacksMapping extends CRM_Bij1migratie_Mapping_AbstractMapping
{
    public const FIELD_CHARGEBACK_ID = 'chargeback_id';
    public const FIELD_CHARGEBACK_DATUM = 'chargeback_datum';
    public const FIELD_TRANSACTIE_ID = 'transactie_id';
    public const FIELD_REDEN_CODE = 'reden_code';
    public const FIELD_REDEN_OMSCHRIJVING = 'reden_omschrijving';
    public const FIELD_BEDRAG = 'bedrag';
    public const FIELD_CHARGEBACK_BEDRAG = 'chargeback_bedrag';
    public const FIELD_MOLLIE_CUSTOMER_ID = 'mollie_customer_id';

    public static $MAPPING = [
        self::FIELD_CHARGEBACK_ID => 1, // id
        self::FIELD_CHARGEBACK_DATUM => 2, // createdAt
        self::FIELD_TRANSACTIE_ID => 3, // paymentId
        self::FIELD_REDEN_CODE => 4, // reason.code
        self::FIELD_REDEN_OMSCHRIJVING => 5, // reason.description
        self::FIELD_BEDRAG => 6, // amount.value
        // amount.currency
        self::FIELD_CHARGEBACK_BEDRAG => 8, // settlementAmount.value
        // settlementAmount.currency
        // payment.resource
        // payment.createdAt
        // payment.paidAt
        // payment.description
        // payment.method
        // payment.status
        // payment.isCancelable
        // payment.sequenceType
        // payment.profileId
        self::FIELD_MOLLIE_CUSTOMER_ID => 19, // payment.customerId
    ];

    public function getColumns(): array
    {
        return self::$MAPPING;
    }
}
