<?php

class CRM_Bij1migratie_Mapping_PersonenMapping extends CRM_Bij1migratie_Mapping_AbstractMapping
{
    // source columns
    public const FIELD_MOLLIE_CUSTOMER_ID = 'mollie_customer_id';
    public const FIELD_NAME = 'name';
    public const FIELD_EMAIL = 'email';
    // destination columns
    public const FIELD_VOORNAAM = 'voornaam';
    public const FIELD_ACHTERNAAM = 'achternaam';

    public static $MAPPING = [
        // resource
        self::FIELD_MOLLIE_CUSTOMER_ID => 1, // id
        // mode
        self::FIELD_NAME => 3,  // in source, not destination
        self::FIELD_VOORNAAM => -1, // we'll get this from the column for name
        self::FIELD_ACHTERNAAM => -1, // dummy value cuz we'll make this from name
        self::FIELD_EMAIL => 4,
        // locale
        // metadata
        // createdAt
        // _links
    ];

    public function getColumns(): array
    {
        return self::$MAPPING;
    }
}
